package  
{
	import flash.display.Sprite;
	import flash.events.MouseEvent
		
	/**
	 * Main2
	 * Purpose: Demo Application to detect a sequence of gesture
	 * @author Shiu		28 October 2011
	 */
	[SWF(width = 500, height = 400 )]
	public class Main2 extends Sprite
	{
		private var ges:MGesture;
		private var gesMan:GManager;
		private var a:Arrows;
		private var seq:Boolean = false;
		
		public function Main2() 
		{
			//Importing graphics in form of movieclip
			a = new Arrows();
			a.stop();
			a.x = 50;
			a.y = 50;
			addChild(a);
			
			//initiating MGesture to allow singular gesture detection
			ges = new MGesture(stage);
			
			//initiating GManager to allow sequential gesture detection
			gesMan = new GManager();
			this.seq = true;
			
			//Detecting gestures in sequence
			if (seq)	{
				a.gotoAndStop(2);
				gesMan.useOrder = true;
			}
			
			//Register gesture sequences in line with frames
			gesMan.register(new < int > [2, 1], "2 Stroke Down, CCW");
			gesMan.register(new < int > [1, 0], "2 Stroke Right, CCW");
			gesMan.register(new < int > [0, 3], "2 Stroke Up, CCW");
			gesMan.register(new < int > [3, 2], "2 Stroke Left, CCW");
			gesMan.register(new < int > [3, 2, 1], "3 Stroke Down, CCW");
			gesMan.register(new < int > [2, 1, 0], "3 Stroke Right, CCW");
			gesMan.register(new < int > [1, 0, 3], "3 Stroke Up, CCW");
			gesMan.register(new < int > [0, 3, 2], "3 Stroke Left, CCW");
			
			gesMan.register(new < int > [3, 0], "2 Stroke Right, CW");
			gesMan.register(new < int > [0, 1], "2 Stroke Down, CW");
			gesMan.register(new < int > [1, 2], "2 Stroke Left, CW");
			gesMan.register(new < int > [2, 3], "2 Stroke Up, CW");
			gesMan.register(new < int > [2, 3, 0], "3 Stroke Right, CW");
			gesMan.register(new < int > [3, 0, 1], "3 Stroke Down, CW");
			gesMan.register(new < int > [0, 1, 2], "3 Stroke Left, CW");
			gesMan.register(new < int > [1, 2, 3], "3 Stroke Up, CW");
			
			gesMan.register(new < int > [0, 3, 0, 3, 0],"Step Up");
			gesMan.register(new < int > [0, 1, 0, 1, 0], "Step Down");
			gesMan.register(new < int > [4], "South East");
			gesMan.register(new < int > [5], "South West");
			gesMan.register(new < int > [6], "North West");
			gesMan.register(new < int > [7], "North East");
			gesMan.register(new < int > [4, 5, 4, 5], "Zigzag");
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN, start);
			stage.addEventListener(MouseEvent.MOUSE_UP, end);
		}
		
		private function start(e:MouseEvent):void 
		{
			//Start detecting singular and sequential gesture
			ges.start();
			gesMan.start();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, check);
			
			//Start drawing gesture
			graphics.clear();
			graphics.lineStyle(3);
			graphics.moveTo(mouseX, mouseY);
		}
		
		private function check(e:MouseEvent):void 
		{
			gesMan.populate(ges.evalDirections());	//Feed singular gesture into a sequence
			graphics.lineTo(mouseX, mouseY)			//Drawing gesture
		}
		
		private function end(e:MouseEvent):void 
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, check);
			var output:Array = gesMan.end()
			trace(output);
			if (output[0] > -1)	{
				if (seq)		a.nextFrame();	//offset needed as first frame is empty.
				else				a.gotoAndStop(output[0] + 2);
			}
		}
		
	}

}